'use strict';

var _slicedToArray2 = require('/Users/sota1235/src/Boostnote/node_modules/babel-runtime/helpers/slicedToArray.js');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _powerAssertVisitorKeys = '{"ArrayExpression":["elements"],"AssignmentExpression":["left","right"],"BinaryExpression":["left","right"],"Directive":["value"],"DirectiveLiteral":[],"BlockStatement":["directives","body"],"BreakStatement":["label"],"CallExpression":["callee","arguments"],"CatchClause":["param","body"],"ConditionalExpression":["test","consequent","alternate"],"ContinueStatement":["label"],"DebuggerStatement":[],"DoWhileStatement":["test","body"],"EmptyStatement":[],"ExpressionStatement":["expression"],"File":["program"],"ForInStatement":["left","right","body"],"ForStatement":["init","test","update","body"],"FunctionDeclaration":["id","params","body","returnType","typeParameters"],"FunctionExpression":["id","params","body","returnType","typeParameters"],"Identifier":["typeAnnotation"],"IfStatement":["test","consequent","alternate"],"LabeledStatement":["label","body"],"StringLiteral":[],"NumericLiteral":[],"NullLiteral":[],"BooleanLiteral":[],"RegExpLiteral":[],"LogicalExpression":["left","right"],"MemberExpression":["object","property"],"NewExpression":["callee","arguments"],"Program":["directives","body"],"ObjectExpression":["properties"],"ObjectMethod":["key","params","body","decorators","returnType","typeParameters"],"ObjectProperty":["key","value","decorators"],"RestElement":["argument","typeAnnotation"],"ReturnStatement":["argument"],"SequenceExpression":["expressions"],"SwitchCase":["test","consequent"],"SwitchStatement":["discriminant","cases"],"ThisExpression":[],"ThrowStatement":["argument"],"TryStatement":["block","handler","finalizer"],"UnaryExpression":["argument"],"UpdateExpression":["argument"],"VariableDeclaration":["declarations"],"VariableDeclarator":["id","init"],"WhileStatement":["test","body"],"WithStatement":["object","body"],"AssignmentPattern":["left","right"],"ArrayPattern":["elements","typeAnnotation"],"ArrowFunctionExpression":["params","body","returnType","typeParameters"],"ClassBody":["body"],"ClassDeclaration":["id","body","superClass","mixins","typeParameters","superTypeParameters","implements","decorators"],"ClassExpression":["id","body","superClass","mixins","typeParameters","superTypeParameters","implements","decorators"],"ExportAllDeclaration":["source"],"ExportDefaultDeclaration":["declaration"],"ExportNamedDeclaration":["declaration","specifiers","source"],"ExportSpecifier":["local","exported"],"ForOfStatement":["left","right","body"],"ImportDeclaration":["specifiers","source"],"ImportDefaultSpecifier":["local"],"ImportNamespaceSpecifier":["local"],"ImportSpecifier":["local","imported"],"MetaProperty":["meta","property"],"ClassMethod":["key","params","body","decorators","returnType","typeParameters"],"ObjectPattern":["properties","typeAnnotation"],"SpreadElement":["argument"],"Super":[],"TaggedTemplateExpression":["tag","quasi"],"TemplateElement":[],"TemplateLiteral":["quasis","expressions"],"YieldExpression":["argument"],"AnyTypeAnnotation":[],"ArrayTypeAnnotation":["elementType"],"BooleanTypeAnnotation":[],"BooleanLiteralTypeAnnotation":[],"NullLiteralTypeAnnotation":[],"ClassImplements":["id","typeParameters"],"ClassProperty":["key","value","typeAnnotation","decorators"],"DeclareClass":["id","typeParameters","extends","body"],"DeclareFunction":["id"],"DeclareInterface":["id","typeParameters","extends","body"],"DeclareModule":["id","body"],"DeclareModuleExports":["typeAnnotation"],"DeclareTypeAlias":["id","typeParameters","right"],"DeclareVariable":["id"],"ExistentialTypeParam":[],"FunctionTypeAnnotation":["typeParameters","params","rest","returnType"],"FunctionTypeParam":["name","typeAnnotation"],"GenericTypeAnnotation":["id","typeParameters"],"InterfaceExtends":["id","typeParameters"],"InterfaceDeclaration":["id","typeParameters","extends","body"],"IntersectionTypeAnnotation":["types"],"MixedTypeAnnotation":[],"EmptyTypeAnnotation":[],"NullableTypeAnnotation":["typeAnnotation"],"NumericLiteralTypeAnnotation":[],"NumberTypeAnnotation":[],"StringLiteralTypeAnnotation":[],"StringTypeAnnotation":[],"ThisTypeAnnotation":[],"TupleTypeAnnotation":["types"],"TypeofTypeAnnotation":["argument"],"TypeAlias":["id","typeParameters","right"],"TypeAnnotation":["typeAnnotation"],"TypeCastExpression":["expression","typeAnnotation"],"TypeParameter":["bound"],"TypeParameterDeclaration":["params"],"TypeParameterInstantiation":["params"],"ObjectTypeAnnotation":["properties","indexers","callProperties"],"ObjectTypeCallProperty":["value"],"ObjectTypeIndexer":["id","key","value"],"ObjectTypeProperty":["key","value"],"QualifiedTypeIdentifier":["id","qualification"],"UnionTypeAnnotation":["types"],"VoidTypeAnnotation":[],"JSXAttribute":["name","value"],"JSXClosingElement":["name"],"JSXElement":["openingElement","children","closingElement"],"JSXEmptyExpression":[],"JSXExpressionContainer":["expression"],"JSXSpreadChild":["expression"],"JSXIdentifier":[],"JSXMemberExpression":["object","property"],"JSXNamespacedName":["namespace","name"],"JSXOpeningElement":["name","attributes"],"JSXSpreadAttribute":["argument"],"JSXText":[],"Noop":[],"ParenthesizedExpression":["expression"],"AwaitExpression":["argument"],"ForAwaitStatement":["left","right","body"],"BindExpression":["object","callee"],"Import":[],"Decorator":["expression"],"DoExpression":["body"],"ExportDefaultSpecifier":["exported"],"ExportNamespaceSpecifier":["exported"],"RestProperty":["argument"],"SpreadProperty":["argument"]}',
    _powerAssertRecorder = function () { function PowerAssertRecorder() { this.captured = []; } PowerAssertRecorder.prototype._capt = function _capt(value, espath) { this.captured.push({ value: value, espath: espath }); return value; }; PowerAssertRecorder.prototype._expr = function _expr(value, source) { var capturedValues = this.captured; this.captured = []; return { powerAssertContext: { value: value, events: capturedValues }, source: source }; }; return PowerAssertRecorder; }();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @fileoverview Unit test for browser/lib/markdown
 */
var test = require('ava');
var markdown = require('../../../boostnote/browser/lib/markdownTextHelper');

test(function (t) {
  // [input, expected]
  var testCases = [
  // List
  [' - ', ' '], [' + ', ' '], [' * ', ' '], [' *   ', ' '], [' 1. ', ' '], [' 2.  ', ' '], [' 10. ', ' '], ["\t- ", "\t"], ['- ', ''],
  // Header with using line
  ["\n==", "\n"], ["\n===", "\n"], ["test\n===", "test\n"],
  // Code block
  ["```test\n", ''], ["```test\nhoge", 'hoge'],
  // HTML tag
  ['<>', ''], ['<test>', 'test'], ['hoge<test>', 'hogetest'], ['<test>moge', 'testmoge'],
  // Emphasis
  ['~~', ''], ['~~text~~', 'text'],
  // Don't remove underscore
  ['`MY_TITLE`', 'MY_TITLE'], ['MY_TITLE', 'MY_TITLE'],
  // I have no idea for it...
  ['```test', '`test']];

  testCases.forEach(function (testCase) {
    var _rec = new _powerAssertRecorder(),
        _rec2 = new _powerAssertRecorder();

    var _testCase = (0, _slicedToArray3.default)(testCase, 2),
        input = _testCase[0],
        expected = _testCase[1];

    t.is(_rec._expr(_rec._capt(_rec._capt(markdown, 'arguments/0/callee/object').strip(_rec._capt(input, 'arguments/0/arguments/0')), 'arguments/0'), {
      content: 't.is(markdown.strip(input), expected, `Test for strip() input: ${input} expected: ${expected}`)',
      filepath: 'tests/lib/markdown-text-helper-test.js',
      line: 44,
      ast: '{"type":"CallExpression","callee":{"type":"MemberExpression","object":{"type":"Identifier","name":"t","range":[0,1]},"property":{"type":"Identifier","name":"is","range":[2,4]},"computed":false,"range":[0,4]},"arguments":[{"type":"CallExpression","callee":{"type":"MemberExpression","object":{"type":"Identifier","name":"markdown","range":[5,13]},"property":{"type":"Identifier","name":"strip","range":[14,19]},"computed":false,"range":[5,19]},"arguments":[{"type":"Identifier","name":"input","range":[20,25]}],"range":[5,26]},{"type":"Identifier","name":"expected","range":[28,36]},{"type":"TemplateLiteral","quasis":[{"type":"TemplateElement","value":{"raw":"Test for strip() input: ","cooked":"Test for strip() input: "},"tail":false,"range":[39,63]},{"type":"TemplateElement","value":{"raw":" expected: ","cooked":" expected: "},"tail":false,"range":[71,82]},{"type":"TemplateElement","value":{"raw":"","cooked":""},"tail":true,"range":[93,93]}],"expressions":[{"type":"Identifier","name":"input","range":[65,70]},{"type":"Identifier","name":"expected","range":[84,92]}],"range":[38,94]}],"range":[0,95]}',
      tokens: '[{"type":{"label":"name"},"value":"t","range":[0,1]},{"type":{"label":"."},"range":[1,2]},{"type":{"label":"name"},"value":"is","range":[2,4]},{"type":{"label":"("},"range":[4,5]},{"type":{"label":"name"},"value":"markdown","range":[5,13]},{"type":{"label":"."},"range":[13,14]},{"type":{"label":"name"},"value":"strip","range":[14,19]},{"type":{"label":"("},"range":[19,20]},{"type":{"label":"name"},"value":"input","range":[20,25]},{"type":{"label":")"},"range":[25,26]},{"type":{"label":","},"range":[26,27]},{"type":{"label":"name"},"value":"expected","range":[28,36]},{"type":{"label":","},"range":[36,37]},{"type":{"label":"`"},"range":[38,39]},{"type":{"label":"template"},"value":"Test for strip() input: ","range":[39,63]},{"type":{"label":"${"},"range":[63,65]},{"type":{"label":"name"},"value":"input","range":[65,70]},{"type":{"label":"}"},"range":[70,71]},{"type":{"label":"template"},"value":" expected: ","range":[71,82]},{"type":{"label":"${"},"range":[82,84]},{"type":{"label":"name"},"value":"expected","range":[84,92]},{"type":{"label":"}"},"range":[92,93]},{"type":{"label":"template"},"value":"","range":[93,93]},{"type":{"label":"`"},"range":[93,94]},{"type":{"label":")"},"range":[94,95]}]',
      visitorKeys: _powerAssertVisitorKeys
    }), _rec2._expr(_rec2._capt(expected, 'arguments/1'), {
      content: 't.is(markdown.strip(input), expected, `Test for strip() input: ${input} expected: ${expected}`)',
      filepath: 'tests/lib/markdown-text-helper-test.js',
      line: 44,
      ast: '{"type":"CallExpression","callee":{"type":"MemberExpression","object":{"type":"Identifier","name":"t","range":[0,1]},"property":{"type":"Identifier","name":"is","range":[2,4]},"computed":false,"range":[0,4]},"arguments":[{"type":"CallExpression","callee":{"type":"MemberExpression","object":{"type":"Identifier","name":"markdown","range":[5,13]},"property":{"type":"Identifier","name":"strip","range":[14,19]},"computed":false,"range":[5,19]},"arguments":[{"type":"Identifier","name":"input","range":[20,25]}],"range":[5,26]},{"type":"Identifier","name":"expected","range":[28,36]},{"type":"TemplateLiteral","quasis":[{"type":"TemplateElement","value":{"raw":"Test for strip() input: ","cooked":"Test for strip() input: "},"tail":false,"range":[39,63]},{"type":"TemplateElement","value":{"raw":" expected: ","cooked":" expected: "},"tail":false,"range":[71,82]},{"type":"TemplateElement","value":{"raw":"","cooked":""},"tail":true,"range":[93,93]}],"expressions":[{"type":"Identifier","name":"input","range":[65,70]},{"type":"Identifier","name":"expected","range":[84,92]}],"range":[38,94]}],"range":[0,95]}',
      tokens: '[{"type":{"label":"name"},"value":"t","range":[0,1]},{"type":{"label":"."},"range":[1,2]},{"type":{"label":"name"},"value":"is","range":[2,4]},{"type":{"label":"("},"range":[4,5]},{"type":{"label":"name"},"value":"markdown","range":[5,13]},{"type":{"label":"."},"range":[13,14]},{"type":{"label":"name"},"value":"strip","range":[14,19]},{"type":{"label":"("},"range":[19,20]},{"type":{"label":"name"},"value":"input","range":[20,25]},{"type":{"label":")"},"range":[25,26]},{"type":{"label":","},"range":[26,27]},{"type":{"label":"name"},"value":"expected","range":[28,36]},{"type":{"label":","},"range":[36,37]},{"type":{"label":"`"},"range":[38,39]},{"type":{"label":"template"},"value":"Test for strip() input: ","range":[39,63]},{"type":{"label":"${"},"range":[63,65]},{"type":{"label":"name"},"value":"input","range":[65,70]},{"type":{"label":"}"},"range":[70,71]},{"type":{"label":"template"},"value":" expected: ","range":[71,82]},{"type":{"label":"${"},"range":[82,84]},{"type":{"label":"name"},"value":"expected","range":[84,92]},{"type":{"label":"}"},"range":[92,93]},{"type":{"label":"template"},"value":"","range":[93,93]},{"type":{"label":"`"},"range":[93,94]},{"type":{"label":")"},"range":[94,95]}]',
      visitorKeys: _powerAssertVisitorKeys
    }), 'Test for strip() input: ' + input + ' expected: ' + expected);
  });
});
//# sourceMappingURL=../../node_modules/.cache/ava/8ead43d83fc564db1c34b3cca6598f02.js.map